MH_cens = function(X,A,m,Nstates,Nabs,Nfailures,pi,initial){

#This is the MH-method for estimating Markov chain realizations

  B = rep(0,(Nstates-Nabs))
  Z = rep(0,(Nstates-Nabs))
  N = matrix(0,nrow = Nstates,ncol = Nstates)
  ttemp = rep(0,Nfailures)
  laststates = rep(0,Nfailures)
  Q = genQLp(A,Nstates,Nabs)[[1]]
  L = genQLp(A,Nstates,Nabs)[[2]]
  Qinv = solve(Q)
  for(i in 1:length(X[,1])){
    if(X[i,3] == 0){
      v_c = rep(0,Nabs)
      v_c[X[i,2]-Nstates+Nabs] = 1
      temp = initial[[i]]
      B_temp = temp[[1]]
      Z_temp = temp[[3]]
      N_temp = temp[[2]]
      ttemp[i] = temp[[4]]
      laststates[i] = temp[[5]]
      for(j in 1:m){
        temp = SimulateMarkov(X[i,1],X[i,2],A,Nstates,Nabs,pi)
        v_temp = rep(0,(Nstates-Nabs))
        v_temp[temp[[5]]] = 1
        v_ttemp = rep(0,(Nstates-Nabs))
        v_ttemp[laststates[i]] = 1
        f_temp = function(t){as.double(v_temp%*%Qinv%*%(-diag(Nstates-Nabs))%*%L%*%t(t(v_c)))}
        marginal_temp = f_temp(0)
        f_ttemp = function(t){as.double(v_ttemp%*%Qinv%*%(-diag(Nstates-Nabs))%*%L%*%t(t(v_c)))}
        marginal_ttemp = f_ttemp(0)
        u = runif(1,0)
        if(((ttemp[i]*marginal_temp)==0) || (u<=(min(1,((temp[[4]]*marginal_ttemp)/(ttemp[i]*marginal_temp)))))){
          B_temp = temp[[1]]
          Z_temp = temp[[3]]
          N_temp = temp[[2]]
          ttemp[i] = temp[[4]]
          laststates[i] = temp[[5]]
          initial[[i]] = temp
        }
      }
    }
    if(X[i,3]==1){
        temp = SimulateMarkov_cens(X[i,1],X[i,2],A,Nstates,Nabs,pi)
        B_temp = temp[[1]]
        Z_temp = temp[[3]]
        N_temp = temp[[2]]
        initial[[i]] = temp
    }
    B = B + B_temp
    Z = Z + Z_temp
    N = N + N_temp
  }
  output = list(B,Z,N,ttemp,initial)
}
