#Initialization of dimensions and iterations

Nstates = 5
Nabs = 2
Nfailures =300
Nburnin = 0
Nsamples = 1000

#Number of MH-steps for each Gibbs-step
Ntune = 1

#Initializing parameters which is to be sampled
t = matrix(0, nrow = Nstates, ncol = Nstates)
pi = rep(0,Nstates-Nabs)

#Creating theoretical parameters

Astates = 4
A = matrix(0,nrow = Astates,ncol = Astates)
A[1,1] = -0.3
A[1,2] = 0.2
A[1,3] = 0.1
A[2,1] = 0
A[2,2] = -0.6
A[2,3] = 0.5
A[2,4] = 0.1
Api = c(1,0)

#Specifying hyper-parameters Nhyp and Bhyp
Nhyp = matrix(0.1,nrow = Nstates,ncol = Nstates)

for(i in 1:(Nstates-Nabs)){
  Nhyp[i,i] = 0
}
for(i in (Nstates-Nabs+1):Nstates){
  Nhyp[,i] = Lscale
}

Nhyp[(Nstates-Nabs+1):Nstates,] = 0


Bhyp = rep(0.01,(Nstates-Nabs))

#Drawing from priors
pi = rdirichlet(1,Bhyp)

c = 500
d = 50
tau = c(0)
theta = c(0)
Zhyp = c(0)
for(i in 1:(Nstates-Nabs)){
  tau[i] = 10
  theta[i] = rgamma(1,shape = c,scale = 1/d)
  Zhyp[i] = rgamma(1,shape = tau[i],scale = 1/theta[i])
}
print(theta)
print(sum(Zhyp))
for(i in 1:(Nstates-Nabs)){
  s = 0
  for(j in 1:Nstates){
    if(i!=j){
       t[i,j] = rgamma(1,shape = Nhyp[i,j],scale = 1/Zhyp[i])
       s = s + t[i,j]
    }
  }
  t[i,i] = -s
}

#Saving prior parameters
priort = t
priorpi = pi


#Creating theoretical and prior parameters to be used in plots
P1 = genQLp(A,Astates,Nabs)
Q1 = P1[[1]]
L1 = P1[[2]]


#Simulating the data to be used

x = SimulateFailures_cens(Nfailures,A,Astates,Nabs,Api)
x[,2] = x[,2]+Nstates-Astates

#Sampling posterior values

initial = list(0)
for(i in 1:Nfailures){
  if(x[i,3]==1){
    initial[[i]] = SimulateMarkov_cens(x[i,1],x[i,2],t,Nstates,Nabs,pi)
  }
  else{
    initial[[i]] = SimulateMarkov(x[i,1],x[i,2],t,Nstates,Nabs,pi)
  }
  print(i)
}

fjvalues = list(0)
pitrace1=c(0)
pitrace2=c(0)
pitrace3=c(0)
tvalues = list(0)
pivalues = list(0)

for(k in 1:(Nburnin+Nsamples)){
  print(k)
  
  #Running Metropolis-Hastings
  Y = MH_cens(x,t,Ntune,Nstates,Nabs,Nfailures,pi,initial)
  B = Y[[1]]
  Z = Y[[2]]
  N = Y[[3]]
  initial = Y[[5]]
  
  #Running Gibbs-step
  pi = rdirichlet(1,(Bhyp+B))
  for(i in 1:(Nstates-Nabs)){
    theta[i] = rgamma(1,shape = c+tau[i], scale = 1/(d+Zhyp[i]))
    Zhyp[i] = rgamma(1,shape = (tau[i]+sum(Nhyp[i,])),scale = 1/(theta[i]-t[i,i]))
  }
  for(i in 1:(Nstates-Nabs)){
    s = 0
    for(j in 1:Nstates){
      if(i!=j){
        t[i,j] = rgamma(1,shape = (Nhyp[i,j] + N[i,j]),scale = 1/(Zhyp[i]+Z[i]))
        s = s + t[i,j]
      }
    }
    t[i,i] = -s
  }
  
  #Saving sample
  if(k>Nburnin){
    tvalues[[k-Nburnin]] = t
    pivalues[[k-Nburnin]] = pi
  }
}

#Creating functional plots

#Functional plots
f = posteriormean(10,0.10,tvalues[900:1000],pivalues[900:1000],A,Api,Nstates,Astates,Nabs,Q1,L1,x,1,1)

 